/* $Id: flexisimpl.cpp,v 1.5 2002/06/29 09:08:18 chrisf Exp $ */

/*
Copyright (C) 2002 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <qapplication.h>
#include <qwidget.h>
#include <qpixmap.h>
#include "flexisinput.h"
#include "flexisimpl.h"

/* XPM */
static const char *flexis_xpm[] = {
"28 13 9 1",
"       c None",
".      c #000000",
"+      c #FFE993",
"@      c #8292FF",
"#      c #F7C500",
"$      c #C69F00",
"%      c #0022FF",
"&      c #000F72",
"*      c #A3732C",
"                        .   ",
"                       .+.  ",
"                      .@#$. ",
"                     .@%&.  ",
"                    .@%&.   ",
"      .            .@%&.    ",
"      .           .@%&.     ",
"      .          .@%&.      ",
"  ... ...   ..  .@%&.       ",
" .  . .  . .   .*.&.        ",
" .  . .  . .   .**.         ",
"  ... ...   .. ...          ",
"                            "};

FlexisImpl::FlexisImpl()
    : input(0), icn(0), ref(0)
{
}

FlexisImpl::~FlexisImpl()
{
    delete input;
    delete icn;
}

QWidget *FlexisImpl::inputMethod(QWidget *parent, Qt::WFlags f)
{
    if (!input) input = new FlexisInput(parent, "Flexis", f);
    return input;
}

void FlexisImpl::resetState()
{
    if (input) input->resetState();
}

QString FlexisImpl::name()
{
    return qApp->translate("InputMethods", "Flexis");
}

QPixmap *FlexisImpl::icon()
{
    if (!icn) icn = new QPixmap((const char **)flexis_xpm);
    return icn;
}

void FlexisImpl::onKeyPress(QObject *receiver, const char *slot)
{
    if (input)
        QObject::connect(input,
            SIGNAL(key(ushort,ushort,ushort,bool,bool)), receiver, slot);
}

#ifndef QT_NO_COMPONENT
QRESULT FlexisImpl::queryInterface(const QUuid &uuid, QUnknownInterface **iface)
{
    *iface = 0;
    if (uuid == IID_QUnknown)
        *iface = this;
    else if (uuid == IID_InputMethod)
        *iface = this;

    if (*iface)
        (*iface)->addRef();
    return QS_OK;
}

Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE(FlexisImpl)
}
#endif
