/* $Id: flexisinput.cpp,v 1.13 2002/07/15 05:19:23 chrisf Exp $ */

/*
Copyright (C) 2002 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <unistd.h>
#include "flexisinput.h"

FlexisInput::FlexisInput(QWidget *parent, const char *name, WFlags fl) :
    QFrame(parent, name, fl)
{
    setFrameStyle(Box|Plain);
    FlexisLayout = new QGridLayout(this);
    if (!FlexisLayout) return;
    FlexisLayout->setSpacing(5);
    FlexisLayout->setMargin(10);
    if ((SerialCheck = new QCheckBox("Serial enabled", this))) {
        FlexisLayout->addWidget(SerialCheck, 0, 0);
        connect(SerialCheck, SIGNAL(toggled(bool)), this,
            SLOT(SerialCheckSlot(bool)));
    }
    if ((TestButton = new QPushButton("Test", this))) {
        FlexisLayout->addWidget(TestButton, 0, 1);
        connect(TestButton, SIGNAL(clicked()), this, SLOT(TestButtonSlot()));
    }
    /* make my fx100 communicator and connect the slot */
    if ((fx100 = new FX100(this))) {
        connect(fx100, SIGNAL(keypress(ushort, ushort, ushort)),
        this, SLOT(fx100slot(ushort, ushort, ushort)));
    }
}

FlexisInput::~FlexisInput()
{
}

QSize FlexisInput::sizeHint() const
{
    return FlexisLayout->sizeHint();
}

void FlexisInput::TestButtonSlot()
{
    QString s("T");
    emit key(s[0].unicode(), 0, 0, true, false);
    emit key(s[0].unicode(), 0, 0, false, false);
}

void FlexisInput::SerialCheckSlot(bool on)
{
    if (on && fx100) fx100->enable();
    if (!on && fx100) fx100->disable();
}

void FlexisInput::fx100slot(ushort uc, ushort qc, ushort mod)
{
    emit key(uc, qc, mod, true, false);
    emit key(uc, qc, mod, false, false);
}
