/* $Id: flexisinput.h,v 1.11 2002/06/29 09:08:18 chrisf Exp $ */

/*
Copyright (C) 2002 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __FLEXISINPUT_H
#define __FLEXISINPUT_H

#include <qwidget.h>
#include <qframe.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include "fx100.h"

class FlexisInput : public QFrame {
    Q_OBJECT
public:
    QPushButton *TestButton;
    QCheckBox *SerialCheck;

    FlexisInput(QWidget *parent=0, const char *name=0, WFlags f=0);
    virtual ~FlexisInput();
    
    void resetState() {}
    QSize sizeHint() const;


public slots:
    void TestButtonSlot();
    void SerialCheckSlot(bool on);
    void fx100slot(ushort uc, ushort qc, ushort mod);

signals:
    void key(ushort scan, ushort uni, ushort mod, bool press, bool repeat);

protected:
    QGridLayout *FlexisLayout;
    FX100 *fx100;
};

#endif
